/*******************************************************************************
 q_eval2.h

*******************************************************************************/
#ifndef _Q_EVAL2_H_
#define _Q_EVAL2_H_

#include <sys/types.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

/* allow up to seven relevance levels plus judged nonrelevant for *compute* */
#define MAXRL_MAX 7  /* max number of relevance levels: do NOT change it */
#define L0LABEL "L0" /* judged nonrelevant */
#define L1LABEL "L1" /* NTCIR B-relevant */
#define L2LABEL "L2" /* NTCIR A-relevant */
#define L3LABEL "L3" /* NTCIR S-relevant */
#define L4LABEL "L4"
#define L5LABEL "L5"
#define L6LABEL "L6"
#define L7LABEL "L7"



#define INTENT_NUMMAX 64      /* number of intents for diversified output */

#define DEFAULT_BETA 1.0       /* for Q-measure */
#define DEFAULT_GAMMA 0.95     /* for rank-biased NCU */
#define DEFAULT_CUTOFF 1000    /* cutoff for prec, hit, nDCG */
#define CUTOFF_NUMMAX 10       /* how many cutoffs? */
#define DEFAULT_LOGB 2.0       /* for original nDCG */
#define DEFAULT_RBP 0.95       /* for RBP */

#define DOCID_SEP " " /* separator between
			    docID and gain value or relevance level */

#define RLEVEL_RLEVEL_SEP ":" /* separator between
                                 gain/stop values for different
                                 rel levels */

#define OPTSTR_HELP    "-h"
#define OPTSTR_VERBOSE "-v"
#define OPTSTR_IGNORE_UNJUDGED  "-j"
#define OPTSTR_IDEALFILE "-I" /* ideal ranked list with gain values */
#define OPTSTR_BETA    "-beta"  /* for Q-measure */
#define OPTSTR_GAMMA   "-gamma" /* for rank-biased NCU */
#define OPTSTR_LOGB    "-logb"  /* for original DCG */
#define OPTSTR_RBP     "-rbp"   /* RBP persistence */
#define OPTSTR_CUTOFF  "-cutoffs" /* cutoffs for prec, hit, nDCG... */
#define OPTSTR_HGAIN   "-hgain" /* highest gain value for gcompute */
#define OPTSTR_OUTSTR  "-out"   /* user specified string as a prefix for
				   each output line
				   This should be useful for printing
				   topicIDs etc. */

#define OPTSTR_RELFILE "-r" /* judged rel/nonrel docs with rel labels */
#define OPTSTR_GAIN "-g" /* gain values for q_eval_compute */
#define OPTSTR_STOP "-s" /* stop values for graded-uniform NCU (compute) */

struct strlist
{
  char *string;
  struct strlist *next;
};

struct strdoublist
{
  char *string;
  double val;
  struct strdoublist *next;
};

struct strstrlist
{
  char *string1;
  char *string2;
  struct strstrlist *next;
};

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif

#endif
